#!/usr/bin/perl

###########################################################
# Sample file showing the use of the xkpasswd Perl module #
###########################################################

# Copyright 2011 Bart Busschots T/A Bartificer Web Solutions. All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are
# permitted provided that the following conditions are met:
#
#   1. Redistributions of source code must retain the above copyright notice, this list of
#      conditions and the following disclaimer.
#
#   2. Redistributions in binary form must reproduce the above copyright notice, this list
#      of conditions and the following disclaimer in the documentation and/or other materials
#      provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY BART BUSSCHOTS T/A BARTIFICER WEB SOLUTIONS ''AS IS'' AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
# BART BUSSCHOTS T/A BARTIFICER WEB SOLUTIONS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# import the library
use xkpasswd;

# if you want to force the libary into debugging mode, set this to 1, default is
# not to debug, so this line is entirely superfluous.
$xkpasswd::DEBUG = 0;

# create a hashref with the initialisation details needed to create an xkpasswd object
my $setupConfig = {
    dictionary_file => 'dict.txt',
    min_word_length => '5',
    max_word_length => '8'
};
# create an instance of an xkpasswd object
my $xkpass = new xkpasswd($setupConfig);

# create a hashref with the settings you wish to use for generating the passwords
# (the accepted keys and their meanings are detailed in the comments in xkpasswd.pm)
my $config = {
    l33t_substitutions => {
        e => '3',
        s => '$',
        a => '4',
    },
    case_transform => 'CAPITAL'
};

# generate a password and print it out
print "\n".$xkpass->generatePassword($config)."\n\n";